/// <reference types="node" />
/// <reference types="svelte" />
import fs from 'fs';
import type { Writable } from 'svelte/store';
export declare const sortFoldersFirst: (a: FileTree, b: FileTree) => number;
export declare const sortByName: (a: fs.Dirent, b: fs.Dirent) => 0 | 1 | -1;
export declare const updateFolders: Writable<number>;
export interface FileTree {
    exists: boolean;
    path: string;
    name: string;
    children: FileTree[];
    childrenStore: Writable<FileTree[]>;
    type: 'folder' | 'file';
    mime: string;
    extension: string;
}
export interface Image extends FileTree {
    thumbnail: Writable<string>;
}
export declare class FileTree {
    constructor(path: string);
    existing(): void;
    hasReadAccess(): boolean;
    hasWriteAccess(): boolean;
    getGrandchildren(isGrandChild?: boolean): void;
    hasExtension(name?: string): RegExpMatchArray | null;
    getExtension(name?: string): string;
    setChildren(fileArray: FileTree[]): void;
    refreshFolder(): void;
    getChildren(): any[];
    traverse(callback: Function): Promise<void>;
}
export declare class Image extends FileTree {
    constructor(path: string);
    getThumbnail(imagePath?: string): void;
}
export declare class Preset extends Image {
    constructor(path: string);
}
